#include "chdecl.h"
void CH_type_stmtchecker(current, sched, cop)
#define ARGUMENTS 14
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 5: goto c7;
    case 3: goto c7;
    case 4: goto cb12;
    case 6: goto c14;
    case 9: goto c18;
    case 7: goto c18;
    case 8: goto cb27;
    case 10: goto c29;
    case 13: goto c33;
    case 11: goto c33;
    case 12: goto cb38;
    case 14: goto c40;
    case 15: goto cb45;
    case 16: goto c46;
    case 17: goto c49;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* new_record 4 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).value = ch_val; REF(4).tsdr = & dr_record;
/* copy 4.0 3.1 */
  if((ch_returncode = (REF(3)DOT(1).tsdr->copy)(& ch_val, REF(3)DOT(1).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(4)DOT(0).tsdr)->finalize)(REF(4)DOT(0).value,F_DISCARD,sched);
  REF(4)DOT(0).value = ch_val;
  REF(4)DOT(0).tsdr = datarepmap[REF(3)DOT(1).tsdr->number];
/* copy 4.1 3.0.0 */
  if((ch_returncode = (REF(3)DOT(0)DOT(0).tsdr->copy)(& ch_val, 
    REF(3)DOT(0)DOT(0).value)) != Normal) goto ch_raise_exception;
  (*(REF(4)DOT(1).tsdr)->finalize)(REF(4)DOT(1).value,F_DISCARD,sched);
  REF(4)DOT(1).value = ch_val;
  REF(4)DOT(1).tsdr = datarepmap[REF(3)DOT(0)DOT(0).tsdr->number];
/* copy 5 3.6.5 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(6)DOT(5).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).value = ch_val;
  REF(5).tsdr = & dr_table;
/* initget 6 5 , 0,0 */
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(6),DEF(5),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c13:
c7:
/* get_or_goto 6 5 , 14 */
  if ((ch_returncode = get_selected_object(DEF(6),DEF(5),sched)) != Normal)
     goto c14;
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
/* lookup_at 8 3.0.2 6.1 */
  if((ch_i = REF(6)DOT(1).value.integer) < 0 || ch_i >= (ch_t = 
    REF(3)DOT(0)DOT(2).value.table)->size) goto ch_notfound;
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(8).value,ch_i);
  REF(8).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 7 8 */
  if((ch_returncode = (REF(8).tsdr->copy)(& ch_val, REF(8).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).value = ch_val;
  REF(7).tsdr = datarepmap[REF(8).tsdr->number];
  current->ip = 4;
cb12:
/* call 3.10 6.0 7 3.4 3.15 3.5 3.7 4 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(10),
          arguments[1] = DEF(6)DOT(0),
          arguments[2] = DEF(7),
          arguments[3] = DEF(3)DOT(4),
          arguments[4] = DEF(3)DOT(15),
          arguments[5] = DEF(3)DOT(5),
          arguments[6] = DEF(3)DOT(7),
          arguments[7] = DEF(4),
          arguments[7+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c14:
/* endget 6 5 */
  end_selector(DEF(6),DEF(5),sched,GET);
/* discard 5 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).tsdr = & dr_bottom;
/* copy 9 3.6.4 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(6)DOT(4).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).value = ch_val;
  REF(9).tsdr = & dr_table;
/* initget 10 9 , 0,0 */
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(10),DEF(9),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c28:
c18:
/* get_or_goto 10 9 , 29 */
  if ((ch_returncode = get_selected_object(DEF(10),DEF(9),sched)) != Normal)
     goto c29;
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
/* discard 11 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).tsdr = & dr_bottom;
/* lookup_at 12 3.0.2 10.2 */
  if((ch_i = REF(10)DOT(2).value.integer) < 0 || ch_i >= (ch_t = 
    REF(3)DOT(0)DOT(2).value.table)->size) goto ch_notfound;
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(12).value,ch_i);
  REF(12).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 7 12 */
  if((ch_returncode = (REF(12).tsdr->copy)(& ch_val, REF(12).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).value = ch_val;
  REF(7).tsdr = datarepmap[REF(12).tsdr->number];
/* lookup_at 13 3.0.2 10.1 */
  if((ch_i = REF(10)DOT(1).value.integer) < 0 || ch_i >= (ch_t = 
    REF(3)DOT(0)DOT(2).value.table)->size) goto ch_notfound;
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(13).value,ch_i);
  REF(13).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 11 13 */
  if((ch_returncode = (REF(13).tsdr->copy)(& ch_val, REF(13).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).value = ch_val;
  REF(11).tsdr = datarepmap[REF(13).tsdr->number];
  current->ip = 8;
cb27:
/* call 3.11 10.0 7 11 3.4 3.15 3.5 3.7 4 , 2 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(11),
          arguments[1] = DEF(10)DOT(0),
          arguments[2] = DEF(7),
          arguments[3] = DEF(11),
          arguments[4] = DEF(3)DOT(4),
          arguments[5] = DEF(3)DOT(15),
          arguments[6] = DEF(3)DOT(5),
          arguments[7] = DEF(3)DOT(7),
          arguments[8] = DEF(4),
          arguments[8+1] = nil,& arguments[0]),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
  return;
c29:
/* endget 10 9 */
  end_selector(DEF(10),DEF(9),sched,GET);
/* discard 9 */
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).tsdr = & dr_bottom;
/* copy 14 3.6.6 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(6)DOT(6).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).value = ch_val;
  REF(14).tsdr = & dr_table;
/* initget 15 14 , 0,0 */
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(15),DEF(14),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c39:
c33:
/* get_or_goto 15 14 , 40 */
  if ((ch_returncode = get_selected_object(DEF(15),DEF(14),sched)) != Normal)
     goto c40;
/* discard 11 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).tsdr = & dr_bottom;
/* lookup_at 16 3.0.2 15.1 */
  if((ch_i = REF(15)DOT(1).value.integer) < 0 || ch_i >= (ch_t = 
    REF(3)DOT(0)DOT(2).value.table)->size) goto ch_notfound;
  (*(REF(16).tsdr)->finalize)(REF(16).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(16).value,ch_i);
  REF(16).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 11 16 */
  if((ch_returncode = (REF(16).tsdr->copy)(& ch_val, REF(16).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).value = ch_val;
  REF(11).tsdr = datarepmap[REF(16).tsdr->number];
  current->ip = 12;
cb38:
/* call 3.12 15.0 11 3.4 3.5 3.7 4 , 3 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(12),
          arguments[1] = DEF(15)DOT(0),
          arguments[2] = DEF(11),
          arguments[3] = DEF(3)DOT(4),
          arguments[4] = DEF(3)DOT(5),
          arguments[5] = DEF(3)DOT(7),
          arguments[6] = DEF(4),
          arguments[6+1] = nil,& arguments[0]),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
  return;
c40:
/* endget 15 14 */
  end_selector(DEF(15),DEF(14),sched,GET);
/* discard 14 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  REF(14).tsdr = & dr_bottom;
/* notequal . 3.0.1 =(5) , 46 */
  if ( REF(3)DOT(0)DOT(1).value.ord_enum != 5 ) goto c46;
  current->ip = 15;
cb45:
/* call 3.13 3.0 3.1 3.2 3.3 3.4 3.5 3.7 3.8 3.9 3.14 3.15 , 4 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(13),
          arguments[1] = DEF(3)DOT(0),
          arguments[2] = DEF(3)DOT(1),
          arguments[3] = DEF(3)DOT(2),
          arguments[4] = DEF(3)DOT(3),
          arguments[5] = DEF(3)DOT(4),
          arguments[6] = DEF(3)DOT(5),
          arguments[7] = DEF(3)DOT(7),
          arguments[8] = DEF(3)DOT(8),
          arguments[9] = DEF(3)DOT(9),
          arguments[10] = DEF(3)DOT(14),
          arguments[11] = DEF(3)DOT(15),
          arguments[11+1] = nil,& arguments[0]),QUAL(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c46:
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c49:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
